SystemOrganization addCategory: #'Scriptaculous-Components-Core'!
SystemOrganization addCategory: #'Scriptaculous-Components-Libraries'!

WAComponent subclass: #SUNavigation
	instanceVariableNames: 'items uid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

SUNavigation subclass: #SUAccordion
	instanceVariableNames: 'visible maxVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUAccordion methodsFor: 'accessing' stamp: 'lr 6/28/2006 10:27'!
cssClass
	^ 'accordion'! !

!SUAccordion methodsFor: 'actions' stamp: 'lr 1/10/2008 01:48'!
hide: anElement
	self visible remove: anElement ifAbsent: [ ]! !

!SUAccordion methodsFor: 'initialization' stamp: 'lr 1/10/2008 01:48'!
initialize
	super initialize.
	visible := OrderedCollection new.
	maxVisible := 1! !

!SUAccordion methodsFor: 'testing' stamp: 'lr 2/20/2007 10:43'!
isVisible: aComponent
	^ self visible includes: aComponent! !

!SUAccordion methodsFor: 'accessing' stamp: 'lr 6/28/2006 09:56'!
maxVisible
	^ maxVisible! !

!SUAccordion methodsFor: 'accessing' stamp: 'lr 6/28/2006 09:57'!
maxVisible: anInteger
	maxVisible := anInteger! !

!SUAccordion methodsFor: 'rendering' stamp: 'lr 1/10/2008 01:49'!
renderBody: anElement index: anInteger visible: aBoolean on: html
	(self isVisible: anElement)
		ifFalse: [ ^ self ].
	html definitionData
		id: (self uid: 'body' at: anInteger);
		style: (aBoolean ifFalse: [ 'display: none' ]);
		with: anElement! !

!SUAccordion methodsFor: 'rendering' stamp: 'obi 5/23/2010 18:37'!
renderHead: anElement index: anInteger on: html
	html definitionTerm 
		id: (self uid: 'head' at: anInteger); 
		class: 'active' if: (self isVisible: anElement);
		with: [
			html anchor
				onClick: (html prototype evaluator
					callback: [ :script | self scriptToggle: anElement on: script ];
					return: false);
				callback: [ self toggle: anElement ];
				with: anElement label ]! !

!SUAccordion methodsFor: 'rendering' stamp: 'lr 2/28/2009 22:33'!
renderNavigationOn: html 
	html definitionList class: self cssClass; with: [
		items keysAndValuesDo: [ :index :element | 
			self renderHead: element index: index on: html.
			self renderBody: element index: index visible: true on: html ] ]! !

!SUAccordion methodsFor: 'scripting' stamp: 'obi 5/29/2010 21:09'!
scriptHide: anElement on: aScript
	| index |
	index := self findIndex: anElement ifAbsent: [ ^ self ].
	aScript scriptaculous effect
		id: (self uid: 'body' at: index);
		onAfterFinish: (PTElement new
						id: (self uid: 'body' at: index); 
						remove);
		duration: 0.2;
		blindUp.
	aScript prototype element
		id: (self uid: 'head' at: index);
		removeClassName: 'active'
		
	
! !

!SUAccordion methodsFor: 'scripting' stamp: 'obi 5/21/2010 20:08'!
scriptShow: anElement on: aScript
	| index |
	index := self findIndex: anElement ifAbsent: [ ^ self ].
	aScript prototype element
		id: (self uid: 'head' at: index);
		insertAfter: [ :html | 
			self 
				renderBody: anElement index: index
				visible: false on: html ].
	aScript scriptaculous effect
		id: (self uid: 'body' at: index);
		duration: 0.2;
		blindDown.
	aScript prototype element
		id: (self uid: 'head' at: index);
		addClassName: 'active'! !

!SUAccordion methodsFor: 'scripting' stamp: 'lr 1/10/2008 01:50'!
scriptToggle: anElement on: aScript
	| previous |
	previous := self visible copy.
	self toggle: anElement.
	(previous difference: self visible)
		do: [ :each | self scriptHide: each on: aScript ].
	(self visible difference: previous)
		do: [ :each | self scriptShow: each on: aScript ]! !

!SUAccordion methodsFor: 'actions' stamp: 'lr 1/10/2008 01:48'!
show: anElement
	self visible addLast: anElement.
	self maxVisible isNil ifFalse: [
		[ self maxVisible < self visible size ]
			whileTrue: [ self hide: self visible first ] ]! !

!SUAccordion methodsFor: 'actions' stamp: 'lr 1/10/2008 01:48'!
toggle: anElement
	(self isVisible: anElement)
		ifTrue: [ self hide: anElement ]
		ifFalse: [ self show: anElement ]! !

!SUAccordion methodsFor: 'accessing' stamp: 'lr 6/28/2006 11:46'!
visible
	^ visible! !

SUNavigation subclass: #SUCarousel
	instanceVariableNames: 'elementExtent numVisible scrollInc offset navMargin elementMargin animationSpeed created'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:24'!
animationSpeed
	^ animationSpeed! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:24'!
animationSpeed: anObject
	animationSpeed := anObject! !

!SUCarousel methodsFor: 'private' stamp: 'lr 7/25/2011 19:56'!
buttonStyle
	^ self subclassResponsibility! !

!SUCarousel methodsFor: 'accessing-bounds' stamp: 'lr 7/25/2011 19:55'!
clipExtent
	^ self subclassResponsibility! !

!SUCarousel methodsFor: 'accessing-bounds' stamp: 'lr 7/25/2011 19:56'!
componentExtent
	^ self subclassResponsibility! !

!SUCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:55'!
cssButton
	^ self subclassResponsibility! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:44'!
cssClass
	^ 'carouselComponent'! !

!SUCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:55'!
cssFloat
	^ self subclassResponsibility! !

!SUCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:55'!
cssOrientation
	^ self subclassResponsibility! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:23'!
elementExtent
	^ elementExtent! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:23'!
elementExtent: anObject
	elementExtent := anObject! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 21:12'!
elementHeight
	^ elementExtent y! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:35'!
elementMargin
	^ elementMargin! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:35'!
elementMargin: anObject
	elementMargin := anObject! !

!SUCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:55'!
elementSize
	^ self subclassResponsibility! !

!SUCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:55'!
elementSizeWithMargins
	^ self elementSize + (2 * elementMargin)! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 21:12'!
elementWidth
	^ elementExtent x! !

!SUCarousel methodsFor: 'initialization' stamp: 'obi 2/16/2008 21:44'!
initialize
	super initialize.
	numVisible := 5.
	elementExtent := Point x: 40 y: 40.
	elementMargin := 5.
	scrollInc := 5.
	animationSpeed := 0.5.
	navMargin := 12.
	offset := 1! !

!SUCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:55'!
lastOffset
	^ offset + numVisible - 1! !

!SUCarousel methodsFor: 'private' stamp: 'lr 7/25/2011 19:55'!
moveSizeX: anInteger
	^ 0! !

!SUCarousel methodsFor: 'private' stamp: 'lr 7/25/2011 19:56'!
moveSizeY: anInteger
	^ 0! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:35'!
navMargin
	^ navMargin! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:35'!
navMargin: anObject
	navMargin := anObject! !

!SUCarousel methodsFor: 'private' stamp: 'lr 7/25/2011 19:55'!
nextText
	^ self subclassResponsibility! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:23'!
numVisible
	^ numVisible! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:23'!
numVisible: anObject
	numVisible := anObject! !

!SUCarousel methodsFor: 'private' stamp: 'lr 7/25/2011 19:55'!
prevText
	^ self subclassResponsibility! !

!SUCarousel methodsFor: 'rendering' stamp: 'jf 9/30/2009 01:10'!
renderElement: element index: index on: html 
	| currentId |
	currentId := self 
		uid: 'head'
		at: index.
	html div
		id: currentId;
		class: 'carousel-element';
		class: self cssFloat;
		style: 'margin:' , elementMargin greaseString , 'px;height:' , self elementHeight greaseString , 'px;width:' , self elementWidth greaseString , 'px;';
		with: element! !

!SUCarousel methodsFor: 'rendering' stamp: 'lr 3/25/2008 22:15'!
renderNavElementsOn: html 
	html div
		class: self cssOrientation;
		id: uid;
		with: [ 
			self visibleItems keysAndValuesDo: [ :index :element | 
				self 
					renderElement: element
					index: index
					on: html ] ]! !

!SUCarousel methodsFor: 'rendering' stamp: 'mlucas-smith 5/14/2010 22:54'!
renderNavigationOn: html
	"reset offset for each full refresh"
	| theExtent clipExtent |
	offset := 1.
	created := self visibleItems.
	theExtent := self componentExtent.
	clipExtent := self clipExtent.
	html div
		class: self cssClass; 
		style: 'height:', theExtent y greaseString, 'px;width:', theExtent x greaseString ,'px' ;
		with: [
			self renderPreviousButtonOn: html.
			html div
				class: 'clip-region';
				class: self cssFloat;
				style: 'height:', clipExtent y greaseString, 'px;width:', clipExtent x greaseString ,'px' ;
				id: 'clip_', uid;
				with: [ self renderNavElementsOn: html ].
			self renderNextButtonOn: html ]! !

!SUCarousel methodsFor: 'rendering' stamp: 'lr 7/25/2011 19:10'!
renderNextButtonOn: html
	html div
		id: uid, '_next';
		style: self buttonStyle;
		class: self cssButton;
		onClick: (html prototype evaluator
					callback: [ :script |
						self scriptMove: -1 for: uid on: script ];
						return: false);
		with: self nextText! !

!SUCarousel methodsFor: 'rendering' stamp: 'lr 7/25/2011 19:10'!
renderPreviousButtonOn: html
	html div
		id: uid, '_prev';
		style: self buttonStyle;
		class: self cssButton;
		onClick: (html prototype evaluator
					callback: [ :script |
						self scriptMove: 1 for: uid on: script ];
						return: false);
		with: self prevText
		
! !

!SUCarousel methodsFor: 'scripting' stamp: 'lr 7/25/2011 19:55'!
scriptMove: anInteger for: id on: script
	"hide buttons to avoid clicks between move operation, works only for IE and firefox"
	
	| currentIndex nextIndex direction buttonId |
	currentIndex := self lastOffset. 
	anInteger = 1 
			ifTrue: [
				offset = 1 ifTrue: [ ^ self ].
				offset := offset - scrollInc.
				direction := '_prev' ]
			ifFalse: [ (offset + scrollInc abs) > (items size) ifTrue: [ ^ self ].
				direction := '_next'.
				offset := offset + scrollInc ].
	anInteger < 0 ifTrue: [
		nextIndex := (currentIndex + scrollInc) min: (items size).
		nextIndex > currentIndex ifTrue: [
		currentIndex + 1 to: nextIndex do: [:idx | | anItem |
			anItem := items at: idx.
			(created includes: anItem) ifFalse: [
				created add: anItem.
				script prototype element
					id: (self uid: 'head' at: idx);
					then: (script prototype element
						id: (self uid: 'head' at: idx - 1);
						insertAfter: [ :html | 
							self renderElement: (items at: idx) index: idx on: html ]) ] ] ] ].
	buttonId := uid,direction.
	script prototype element
		id: buttonId;
		styleAt: 'visibility' put: 'hidden'.
	script scriptaculous effect id: id;
		duration: animationSpeed;
		y: (self moveSizeY: anInteger); x: (self moveSizeX: anInteger);
		move;
		onAfterFinish: (PTElement new id: buttonId; styleAt: 'visibility' put: 'visible').
! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:23'!
scrollInc
	^ scrollInc! !

!SUCarousel methodsFor: 'accessing' stamp: 'obi 2/13/2008 20:23'!
scrollInc: anObject
	scrollInc := anObject! !

!SUCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:55'!
visibleItems
	^ items copyFrom: offset to: (self lastOffset min: items size)! !

SUCarousel subclass: #SUHorizontalCarousel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUHorizontalCarousel methodsFor: 'private' stamp: 'lr 7/25/2011 19:56'!
buttonStyle
	^ 'width:' , navMargin greaseString , 'px;line-height:' , self componentExtent y greaseString , 'px;'! !

!SUHorizontalCarousel methodsFor: 'accessing-bounds' stamp: 'lr 7/25/2011 19:56'!
clipExtent
	| xSize ySize |
	xSize := elementExtent x + (2 * elementMargin).
	ySize := elementExtent y.
	^ Point x: numVisible * xSize y: ySize + (2 * elementMargin)! !

!SUHorizontalCarousel methodsFor: 'accessing-bounds' stamp: 'lr 7/25/2011 19:56'!
componentExtent
	| clipExtent |
	clipExtent := self clipExtent.
	^ Point x: clipExtent x + (navMargin * 2) + 3 y: clipExtent y! !

!SUHorizontalCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:56'!
cssButton
	^ 'buttonh'! !

!SUHorizontalCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:56'!
cssFloat
	^ 'carousel-float-h'! !

!SUHorizontalCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:56'!
cssOrientation
	^ 'carousel-list-h'! !

!SUHorizontalCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:56'!
elementSize
	^ self elementExtent x! !

!SUHorizontalCarousel methodsFor: 'private' stamp: 'obi 2/17/2008 08:54'!
moveSizeX: anInteger 
	^ self elementSizeWithMargins * scrollInc * anInteger! !

!SUHorizontalCarousel methodsFor: 'private' stamp: 'lr 7/25/2011 19:56'!
nextText
	^ '>'! !

!SUHorizontalCarousel methodsFor: 'private' stamp: 'lr 7/25/2011 19:56'!
prevText
	^ '<'! !

SUCarousel subclass: #SUVerticalCarousel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUVerticalCarousel methodsFor: 'private' stamp: 'lr 7/25/2011 19:56'!
buttonStyle
	^ 'height:' , navMargin greaseString , 'px;'! !

!SUVerticalCarousel methodsFor: 'accessing-bounds' stamp: 'obi 2/16/2008 10:52'!
clipExtent
	| xSize ySize |
	xSize := elementExtent x.
	ySize := elementExtent y + (2 * elementMargin).
	^ Point x: xSize + (2 * elementMargin) y: ySize * numVisible! !

!SUVerticalCarousel methodsFor: 'accessing-bounds' stamp: 'lr 7/25/2011 19:56'!
componentExtent
	| clipExtent |
	clipExtent := self clipExtent.
	^ Point x: clipExtent x y: clipExtent y + (navMargin * 2) + 3! !

!SUVerticalCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:56'!
cssButton
	^ 'buttonv'! !

!SUVerticalCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:56'!
cssFloat
	^ 'carousel-float-v'! !

!SUVerticalCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:56'!
cssOrientation
	^ 'carousel-list-v'! !

!SUVerticalCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:56'!
elementSize
	^ self elementExtent y! !

!SUVerticalCarousel methodsFor: 'private' stamp: 'lr 7/25/2011 19:56'!
moveSizeY: anInteger
	^ self elementSizeWithMargins * scrollInc * anInteger! !

!SUVerticalCarousel methodsFor: 'private' stamp: 'lr 7/25/2011 19:56'!
nextText
	^ '\/'! !

!SUVerticalCarousel methodsFor: 'private' stamp: 'lr 7/25/2011 19:56'!
prevText
	^ '/\'! !

!SUNavigation methodsFor: 'public' stamp: 'lr 1/10/2008 08:50'!
add: anObject
	"Add anObject to the collection of child items. Answer an instance of SUNavigationItem."

	^ items add: (self navigationItemClass on: self body: anObject)! !

!SUNavigation methodsFor: 'public' stamp: 'lr 1/10/2008 01:40'!
add: anObject label: aString
	^ (self add: anObject) label: aString! !

!SUNavigation methodsFor: 'accessing' stamp: 'obi 3/2/2008 19:48'!
children
	^ self visibleComponentsFor: self visible! !

!SUNavigation methodsFor: 'accessing' stamp: 'lr 1/10/2008 08:53'!
cssClass
	"Answer the css class the outermost DOM element will use."

	self subclassResponsibility! !

!SUNavigation methodsFor: 'private' stamp: 'lr 1/10/2008 08:53'!
findIndex: anItem ifAbsent: aBlock 
	| index |
	index := items findFirst: [ :each | each = anItem ].
	index isZero ifTrue: [ aBlock value ].
	^ index! !

!SUNavigation methodsFor: 'initialization' stamp: 'lr 1/10/2008 08:47'!
initialize
	super initialize.
	items := OrderedCollection new! !

!SUNavigation methodsFor: 'accessing' stamp: 'lr 1/10/2008 08:53'!
navigationItemClass
	"Answer the navigation class to represent the child items."

	^ SUNavigationItem! !

!SUNavigation methodsFor: 'public' stamp: 'lr 1/10/2008 08:51'!
remove: anItem
	"Remove anItem from the collection of child items."

	^ items remove: anItem ifAbsent: [ nil ]! !

!SUNavigation methodsFor: 'rendering' stamp: 'lr 1/4/2008 13:16'!
renderContentOn: html
	uid := html nextId.
	self renderNavigationOn: html! !

!SUNavigation methodsFor: 'rendering' stamp: 'lr 1/4/2008 13:16'!
renderNavigationOn: html
	self subclassResponsibility! !

!SUNavigation methodsFor: 'private' stamp: 'lr 1/10/2008 02:06'!
uid
	^ uid! !

!SUNavigation methodsFor: 'private' stamp: 'mlucas-smith 5/14/2010 22:54'!
uid: aString at: anInteger
	^ uid , '_' , aString , '_' , anInteger greaseString! !

!SUNavigation methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:54'!
visible
	"override in subclasses if not all items are displayed, see for example SUTabPanel"

	^ items! !

!SUNavigation methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:54'!
visibleComponentsFor: aCollection
	^ (aCollection select: [ :each | each isComponent ]) collect: [ :each | each body ]! !

SUNavigation subclass: #SUNavigationCarousel
	instanceVariableNames: 'selected elementHeight visibleElements offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUNavigationCarousel methodsFor: 'accessing' stamp: 'lr 1/10/2008 01:28'!
cssClass
	^ 'carousel'! !

!SUNavigationCarousel methodsFor: 'accessing' stamp: 'obi 1/12/2008 17:55'!
elementHeight
	"Answer the value of elementHeight"

	^ elementHeight! !

!SUNavigationCarousel methodsFor: 'accessing' stamp: 'obi 1/12/2008 17:55'!
elementHeight: anObject
	"Set the value of elementHeight"

	elementHeight := anObject! !

!SUNavigationCarousel methodsFor: 'initialization' stamp: 'obi 1/12/2008 18:52'!
initialize
	super initialize.
	visibleElements := 5.
	elementHeight := 14.
	offset := 1! !

!SUNavigationCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
innerHeight
	^ elementHeight * visibleElements! !

!SUNavigationCarousel methodsFor: 'rendering' stamp: 'lr 7/25/2011 19:11'!
renderActionsForId: id on: html
	html table style: 'width:100%;margin-top:10px'; with: [
		html tableRow: [
			html tableData class: 'action'; with: 
				[html anchor onClick: ((html prototype evaluator)
								callback: [ :script | self scriptMove: 1 for: id on: script ];return: false);
								with: 'Previous'].
				html tableData style: 'width:100%'; with: [html space].
				html tableData class: 'action'; class: 'right'; 
						with: [html anchor
								onClick: ((html prototype evaluator)
								callback: [ :script | self scriptMove: -1 for: id on: script ];return: false);
								with: 'Next' ] ] ]! !

!SUNavigationCarousel methodsFor: 'rendering' stamp: 'obi 1/12/2008 11:42'!
renderBodyOn: html
	html div
		id: (self uid: 'body' at: 0);
		class: 'body';
		with: self selected! !

!SUNavigationCarousel methodsFor: 'rendering' stamp: 'obi 5/21/2010 20:12'!
renderElement: element index: index on: html 
	| currentId |
	currentId := self 
		uid: 'head'
		at: index.
	html div
		id: currentId;
		class: 'active'
			if: self selected = element;
		style: 'height:' , self elementHeight greaseString , 'px';
		with: 
			[ html anchor
				onClick: (html prototype evaluator
						callback: 
							[ :script | 
							self 
								scriptSelected: element
								id: currentId
								on: script ];
						return: false);
				callback: [ self selected: element ];
				with: [ html div: element label ] ]! !

!SUNavigationCarousel methodsFor: 'rendering' stamp: 'mlucas-smith 5/14/2010 22:54'!
renderNavElementsOn: html 
	| moveId |
	moveId := html nextId.
	html div
		class: 'nav';
		with: [
			html div
				style: 'height:' , self innerHeight greaseString , 'px';
				class: 'inner';
				with: [
					html div
						id: moveId;
						class: 'move';
						with: [ 
							items keysAndValuesDo: [ :index :element | 
								self 
									renderElement: element
									index: index
									on: html ] ] ].
			self 
				renderActionsForId: moveId
				on: html ]! !

!SUNavigationCarousel methodsFor: 'rendering' stamp: 'obi 9/8/2008 20:46'!
renderNavigationOn: html
	"reset offset for each full refresh"
	offset := 1.
	html div 
		class: self cssClass;
		with: [
			html table: [
				html tableRow: [
					html tableData: [self renderNavElementsOn: html].
					html tableData
						verticalAlign: 'top';
						with: [self renderBodyOn: html ] ] ] ]! !

!SUNavigationCarousel methodsFor: 'scripting' stamp: 'lr 7/25/2011 19:11'!
scriptMove: anInteger for: id on: script
	| elementsToMove |
	elementsToMove := visibleElements - 1.
	anInteger = 1
		ifTrue: [ 
			offset = 1
				ifTrue: [ ^ self ].
			offset := offset - elementsToMove ]
		ifFalse: [ 
			offset + elementsToMove abs > items size
				ifTrue: [ ^ self ].
			offset := offset + elementsToMove ].
	script scriptaculous effect
		id: id;
		duration: 0.2;
		x: 0;
		y: self elementHeight * elementsToMove * anInteger;
		move! !

!SUNavigationCarousel methodsFor: 'scripting' stamp: 'lr 7/25/2011 18:38'!
scriptSelected: aComponent id: currentId on: aScript
	aScript prototype element
		id: (self uid: 'head' at: (self findIndex: self selected ifAbsent: [ ]));
		removeClassName: 'active'.
	self selected: aComponent.
	aScript prototype element
		id: currentId;
		addClassName: 'active'.
	aScript prototype element
		id: (self uid: 'body' at: 0);
		update: self selected! !

!SUNavigationCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 18:38'!
selected
	^ selected ifNil: [ selected := items isEmpty ifFalse: [ items first ] ]! !

!SUNavigationCarousel methodsFor: 'accessing' stamp: 'obi 1/12/2008 11:41'!
selected: anElement
	selected := anElement! !

!SUNavigationCarousel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
visible
	selected ifNil: [ ^ #() ].
	^ Array with: selected! !

!SUNavigationCarousel methodsFor: 'accessing' stamp: 'obi 1/12/2008 17:55'!
visibleElements
	"Answer the value of visibleElements"

	^ visibleElements! !

!SUNavigationCarousel methodsFor: 'accessing' stamp: 'obi 1/12/2008 17:55'!
visibleElements: anObject
	"Set the value of visibleElements"

	visibleElements := anObject! !

SUNavigation subclass: #SUTabPanel
	instanceVariableNames: 'selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUTabPanel methodsFor: 'accessing' stamp: 'lr 1/4/2008 11:41'!
cssClass
	^ 'tabPanel'! !

!SUTabPanel methodsFor: 'rendering' stamp: 'obi 9/8/2008 20:47'!
renderNavigationOn: html
	html div
		class: self cssClass;
		with: [
			self renderTabsOn: html.
			self renderPanelOn: html ]! !

!SUTabPanel methodsFor: 'rendering' stamp: 'lr 2/19/2007 13:45'!
renderPanelOn: html
	html div
		id: (self uid: 'body' at: 0);
		class: 'body';
		with: self selected! !

!SUTabPanel methodsFor: 'rendering' stamp: 'obi 5/21/2010 20:10'!
renderTabsOn: html 
	| active |
	html unorderedList
		class: 'head';
		with: [
			items keysAndValuesDo: [ :index :element | 
				active := self selected = element.
				html listItem: [
					html anchor
						id: (self uid: 'head' at: index);
						class: 'active' if: active;
						onClick: (html prototype evaluator
							callback: [ :script | self scriptSelected: element on: script ];
							return: false);
						callback: [self selected: element];
						with: element label ] ] ]! !

!SUTabPanel methodsFor: 'scripting' stamp: 'obi 5/21/2010 20:09'!
scriptSelected: aComponent on: aScript
	aScript prototype element
		id: (self uid: 'head' at: (self
			findIndex: self selected
			ifAbsent: [ ]));
		removeClassName: 'active'.
	self selected: aComponent.
	aScript prototype element
		id: (self uid: 'head' at: (self
			findIndex: self selected
			ifAbsent: [ ^ self ]));
		addClassName: 'active'.
	aScript prototype element
		id: (self uid: 'body' at: 0);
		update: self selected! !

!SUTabPanel methodsFor: 'accessing' stamp: 'lr 1/10/2008 17:06'!
selected
	^ selected ifNil: [ selected := items isEmpty ifFalse: [ items first ] ]! !

!SUTabPanel methodsFor: 'accessing' stamp: 'lr 1/10/2008 01:46'!
selected: anElement
	selected := anElement! !

!SUTabPanel methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
visible
	selected ifNil: [ ^ #() ].
	^ Array with: selected! !

WAComponent subclass: #SUSplitter
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

SUSplitter subclass: #SUHorizontalSplitter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUHorizontalSplitter methodsFor: 'accessing' stamp: 'lr 2/1/2008 17:10'!
cssClass
	^ 'splitter-horizontal'! !

!SUHorizontalSplitter methodsFor: 'scripts' stamp: 'obi 5/22/2010 23:22'!
draggable: aBeforeItem and: anAfterItem on: html 
	^ (super 
		draggable: aBeforeItem
		and: anAfterItem
		on: html)
		constraintVertical;
		onDrag: (JSStream on: '
				var splitter = arguments[0].element;
				offset = splitter.offsetTop - arguments[0]._originalTop;
				arguments[0]._originalTop = splitter.offsetTop;
				leftElement = arguments[0]._previous;
				leftHeight = leftElement.offsetHeight + offset;
				rightElement = arguments[0]._next;
				rightHeight = rightElement.offsetHeight - offset;
				if (leftHeight > ' , aBeforeItem min greaseString , ' && rightHeight > ' , anAfterItem min greaseString , ') {
					leftElement.style.height = leftHeight + "px";
					rightElement.style.height = rightHeight + "px";
				}');
		onEnd: (html prototype request
				callback: [ :value | aBeforeItem size: value ]
					value: (JSStream on: 'arguments[0].element.previous().offsetHeight + ''px''');
				callback: [ :value | anAfterItem size: value ]
					value: (JSStream on: 'arguments[0].element.next().offsetHeight + ''px'''))! !

!SUHorizontalSplitter methodsFor: 'scripts' stamp: 'lr 7/25/2011 19:54'!
initOffsetScript
	^ 'drag._originalTop=splitter.offsetTop;'! !

!SUHorizontalSplitter methodsFor: 'rendering' stamp: 'obi 2/2/2008 09:46'!
renderItem: anItem on: html
	html div style: 'height:' , anItem size; with: anItem body! !

!SUSplitter methodsFor: 'public' stamp: 'lr 2/1/2008 16:48'!
add: anObject
	^ items add: (SUSplitterItem on: self body: anObject)! !

!SUSplitter methodsFor: 'public' stamp: 'lr 2/1/2008 16:48'!
add: anObject size: aString
	^ (self add: anObject) size: aString! !

!SUSplitter methodsFor: 'public' stamp: 'obi 5/5/2008 20:28'!
add: anObject size: aString min: anInteger
	^ (self add: anObject) size: aString; min: anInteger! !

!SUSplitter methodsFor: 'accessing' stamp: 'lr 2/1/2008 16:28'!
children
	^ (items select: [ :each | each isComponent ]) collect: [ :each | each body ]! !

!SUSplitter methodsFor: 'accessing' stamp: 'lr 2/1/2008 17:10'!
cssClass
	^ self subclassResponsibility! !

!SUSplitter methodsFor: 'scripts' stamp: 'obi 2/11/2009 20:59'!
draggable: aBeforeItem and: anAfterItem on: html
	^ html scriptaculous draggable
		revert: true;
		endEffect: nil;
		startEffect: nil;
		onStart: ((JSStream on: 'var splitter = drag.element;',
								self initOffsetScript ,'
								drag._previous = splitter.previous();
								drag._next = splitter.next();')
			asFunction: #(drag))! !

!SUSplitter methodsFor: 'scripts' stamp: 'obi 2/3/2008 20:47'!
initOffsetScript
	^ self subclassResponsibility! !

!SUSplitter methodsFor: 'initialization' stamp: 'lr 2/1/2008 16:41'!
initialize
	super initialize.
	items := OrderedCollection new! !

!SUSplitter methodsFor: 'accessing' stamp: 'lr 2/1/2008 16:49'!
items
	^ items! !

!SUSplitter methodsFor: 'rendering' stamp: 'lr 2/1/2008 17:24'!
renderContentOn: html
	html div class: self cssClass; with: [
		1 to: self items size do: [ :index |
			self renderItem: (self items at: index) on: html.
			self items size = index ifFalse: [ 
				self
					renderSplitter: (self items at: index) 
					and: (self items at: index + 1) 
					on: html ] ] ]! !

!SUSplitter methodsFor: 'rendering' stamp: 'lr 2/1/2008 16:35'!
renderItem: anItem on: html
	self subclassResponsibility! !

!SUSplitter methodsFor: 'rendering' stamp: 'lr 2/1/2008 17:20'!
renderSplitter: aBeforeItem and: anAfterItem on: html
	html div 
		class: 'handle'; 
		script: (self 
			draggable: aBeforeItem 
			and: anAfterItem
			on: html)! !

SUSplitter subclass: #SUVerticalSplitter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUVerticalSplitter methodsFor: 'accessing' stamp: 'lr 2/1/2008 17:10'!
cssClass
	^ 'splitter-vertical'! !

!SUVerticalSplitter methodsFor: 'scripts' stamp: 'obi 5/22/2010 23:22'!
draggable: aBeforeItem and: anAfterItem on: html 
	^ (super 
		draggable: aBeforeItem
		and: anAfterItem
		on: html)
		constraintHorizontal;
		onDrag: (JSStream on: '
				var splitter = arguments[0].element;
				offset = splitter.offsetLeft - arguments[0]._originalLeft;
				arguments[0]._originalLeft = splitter.offsetLeft;
				leftElement = arguments[0]._previous;
				leftWidth = leftElement.offsetWidth + offset;
				rightElement = arguments[0]._next;
				rightWidth = rightElement.offsetWidth - offset;
				if (leftWidth > ' , aBeforeItem min greaseString , ' && rightWidth > ' , anAfterItem min greaseString , ') {
					leftElement.style.width = leftWidth + "px";
					rightElement.style.width = rightWidth + "px";
				}');
		onEnd: (html prototype request
				callback: [ :value | aBeforeItem size: value ]
					value: (JSStream on: 'arguments[0].element.previous().offsetWidth + ''px''');
				callback: [ :value | anAfterItem size: value ]
					value: (JSStream on: 'arguments[0].element.next().offsetWidth + ''px'''))! !

!SUVerticalSplitter methodsFor: 'scripts' stamp: 'lr 7/25/2011 19:57'!
initOffsetScript
	^ 'drag._originalLeft=splitter.offsetLeft;'! !

!SUVerticalSplitter methodsFor: 'rendering' stamp: 'obi 2/2/2008 09:46'!
renderItem: anItem on: html
	html div style: 'width:' , anItem size; with: anItem body! !

WAComponent subclass: #SUTieredList
	instanceVariableNames: 'selectionPath childrenBlock labelBlock uid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUTieredList methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:40'!
children: aOneArgumentBlock
	"Define a one argument block that answers a collection of children for a given node."

	childrenBlock := aOneArgumentBlock! !

!SUTieredList methodsFor: 'accessing' stamp: 'lr 1/4/2008 11:41'!
cssClass
	^ 'tieredList'! !

!SUTieredList methodsFor: 'initialization' stamp: 'lr 8/9/2007 14:50'!
initialize
	super initialize.
	selectionPath := OrderedCollection new.
	childrenBlock := [ :value | #() ].
	labelBlock := [ :value | value printString ]! !

!SUTieredList methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:40'!
labels: aOneArgumentBlock
	"Define a one argument block that answers a string for a given node."

	labelBlock := aOneArgumentBlock! !

!SUTieredList methodsFor: 'rendering' stamp: 'lr 1/4/2008 11:42'!
renderContentOn: html
	html div
		class: self cssClass;
		id: (uid := html nextId);
		with: [ self renderListOn: html ]! !

!SUTieredList methodsFor: 'rendering' stamp: 'obi 2/11/2009 20:47'!
renderList: aCollection level: anInteger on: html
	| id selected |
	aCollection isEmpty ifTrue: [ ^ self ].
	html select
		beOptional;
		list: aCollection;
		labels: labelBlock;
		id: (id := html nextId);
		optionalLabel: '(select)';
		selected: (selected := selectionPath
			at: anInteger
			ifAbsent: [ nil ]);
		callback: [ :value |
			[ selectionPath size < anInteger ]
		 		whileFalse: [ selectionPath removeLast ].
			selectionPath addLast: value ];
		onChange: (html scriptaculous updater
			id: uid;
			triggerFormElement: id;
			callback: [ :r | self renderListOn: r ]).
	selected isNil
		ifFalse: [ self renderList: (childrenBlock value: selected) level: anInteger + 1 on: html ]! !

!SUTieredList methodsFor: 'rendering' stamp: 'lr 10/28/2007 14:40'!
renderListOn: html
	selectionPath isEmpty
		ifFalse: [ self renderList: (childrenBlock value: selectionPath first) level: 2 on: html ]! !

!SUTieredList methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:40'!
selection
	"Answer the selection path including the root node."

	^ selectionPath! !

!SUTieredList methodsFor: 'accessing' stamp: 'lr 10/28/2007 14:40'!
selection: anOrderedCollection
	"Set the selection path including the root node."

	selectionPath := anOrderedCollection! !

WAComponent subclass: #SUTitlePane
	instanceVariableNames: 'title body open uid loaded alwaysRefresh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/14/2008 23:15'!
alwaysRefresh
	"Answer the value of alwaysRefresh"

	^ alwaysRefresh! !

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/14/2008 23:15'!
alwaysRefresh: anObject
	"Set the value of alwaysRefresh"

	alwaysRefresh := anObject! !

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/13/2008 21:30'!
body
	"Answer the value of body"

	^ body! !

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/13/2008 21:30'!
body: anObject
	"Set the value of body"

	body := anObject! !

!SUTitlePane methodsFor: 'accessing' stamp: 'lr 7/25/2011 18:39'!
children
	^ (body isKindOf: WAComponent)
		ifTrue: [ Array with: body ]
		ifFalse: [ #() ]! !

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/14/2008 20:37'!
cssClass
	^ 'titlePane'! !

!SUTitlePane methodsFor: 'initialization' stamp: 'obi 2/17/2008 12:55'!
initialize
	super initialize.
	open := false.
	loaded := false.
	alwaysRefresh := true.! !

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/14/2008 23:15'!
loaded
	"Answer the value of loaded"

	^ loaded! !

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/14/2008 23:15'!
loaded: anObject
	"Set the value of loaded"

	loaded := anObject! !

!SUTitlePane methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
mainId
	^ 'main' , uid! !

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/13/2008 22:34'!
open
	"Answer the value of open"

	^ open! !

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/13/2008 22:34'!
open: anObject
	"Set the value of open"

	open := anObject! !

!SUTitlePane methodsFor: 'rendering' stamp: 'lr 7/25/2011 18:39'!
renderBodyOn: html
	html div
		id: uid;
		class: 'body';
		class: 'closed' if: open not;
		with: [ open ifTrue: [ html render: body ] ]! !

!SUTitlePane methodsFor: 'rendering' stamp: 'lr 7/25/2011 18:40'!
renderContentOn: html
	uid := html nextId.
	html div
		id: self mainId;
		class: self cssClass;
		with: [ 
			html div: [ 
				self renderTitleOn: html.
				self renderBodyOn: html ] ]! !

!SUTitlePane methodsFor: 'rendering' stamp: 'lr 7/25/2011 18:39'!
renderTitleOn: html
	html anchor class: 'title'; 
		callback: [ open := open not ];
		onClick: (html prototype evaluator
						callback: [ :script | self scriptToggleOn: script ];
						return: false);
		 with: [
			html table
				style: 'width:100%';
				cellspacing: 0;
				with: [
					html tableRow: [
						html tableData
							class: 'label';
							with: title.
						html tableData: [
							html div
								id: 'gfx',uid;
								class: 'gfxopen' if: open;
								class: 'gfx' if: open not ] ] ] ]! !

!SUTitlePane methodsFor: 'scripting' stamp: 'lr 7/25/2011 18:39'!
scriptToggleOn: script
	open
		ifTrue: [ 
			(script scriptaculous effect)
				id: uid;
				duration: 0.3;
				blindUp.
			(script prototype element)
				id: 'gfx' , uid;
				removeClassName: 'gfxopen';
				addClassName: 'gfx' ]
		ifFalse: [ 
			(loaded not or: [ alwaysRefresh ])
				ifTrue: [ 
					(script prototype element)
						id: uid;
						update: body.
					loaded := true ].
			(script prototype element)
				id: uid;
				removeClassName: 'closed'.
			(script prototype element)
				id: 'gfx' , uid;
				removeClassName: 'gfx';
				addClassName: 'gfxopen'.
			(script scriptaculous effect)
				id: uid;
				duration: 0.3;
				blindDown ].
	open := open not! !

!SUTitlePane methodsFor: 'public' stamp: 'obi 1/14/2008 23:15'!
startOpen
	"Set the value of open and loaded"
	"use this if the content should be open and rendered at startup"

	open := true.
	loaded := true! !

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/13/2008 21:30'!
title
	"Answer the value of title"

	^ title! !

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/13/2008 21:30'!
title: anObject
	"Set the value of title"

	title := anObject! !

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/13/2008 22:34'!
uid
	"Answer the value of uid"

	^ uid! !

!SUTitlePane methodsFor: 'accessing' stamp: 'obi 1/13/2008 22:34'!
uid: anObject
	"Set the value of uid"

	uid := anObject! !

WAComponent subclass: #SUTreeReport
	instanceVariableNames: 'uids roots columns expanded childrenBlock expandableBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUTreeReport methodsFor: 'accessing' stamp: 'lr 1/14/2008 20:35'!
addColumn: aBlock label: aString
	^ columns add: ((self treeReportColumnClass on: self)
		renderer: aBlock;
		label: aString;
		yourself)! !

!SUTreeReport methodsFor: 'accessing' stamp: 'lr 11/29/2007 17:00'!
children: aBlock
	childrenBlock := aBlock! !

!SUTreeReport methodsFor: 'scripts' stamp: 'obi 5/21/2010 20:16'!
collapse: anObject level: anInteger on: aScript
	self recursiveCollapse: anObject on: aScript.
	aScript prototype element
		down: '.indent a';
		removeClassName: 'expanded';
		id: (self uid: anObject on: aScript)! !

!SUTreeReport methodsFor: 'accessing' stamp: 'lr 1/4/2008 11:43'!
cssClass
	^ 'treeReport'! !

!SUTreeReport methodsFor: 'accessing' stamp: 'lr 1/4/2008 12:35'!
expand: anObject
	expanded add: anObject! !

!SUTreeReport methodsFor: 'scripts' stamp: 'obi 5/21/2010 20:16'!
expand: anObject level: anInteger on: aScript
	| children parentId |
	children := childrenBlock value: anObject.
	children isEmpty ifTrue: [ ^ self ].
	parentId := self uid: anObject on: aScript.
	aScript prototype element
		id: parentId; 
		down: '.indent a';
		addClassName: 'expanded'.
	aScript prototype insertion
		id: parentId;
		after: [ :html | 
			children do: [ :each |
				self renderRow: each level: anInteger + 1 on: html ] ].
	expanded add: anObject! !

!SUTreeReport methodsFor: 'accessing' stamp: 'lr 11/29/2007 17:00'!
expandable: aBlock
	expandableBlock := aBlock! !

!SUTreeReport methodsFor: 'initialization' stamp: 'lr 11/29/2007 17:00'!
initialize
	super initialize.
	roots := OrderedCollection new.
	columns := OrderedCollection new.
	expanded := IdentitySet new.
	childrenBlock := [ :value | #() ].
	expandableBlock := [ :value | (childrenBlock value: value) notEmpty ]! !

!SUTreeReport methodsFor: 'testing' stamp: 'lr 1/14/2008 21:01'!
isExpandable: anObject
	^ expandableBlock value: anObject! !

!SUTreeReport methodsFor: 'testing' stamp: 'lr 1/14/2008 21:01'!
isExpanded: anObject
	^ expanded includes: anObject! !

!SUTreeReport methodsFor: 'private' stamp: 'obi 5/21/2010 20:16'!
recursiveCollapse: anObject on: aScript
	expanded remove: anObject.
	(childrenBlock value: anObject) do: [ :each |
		aScript prototype element
			id: (self uid: each on: aScript);
			remove.
		(expanded includes: each)
			ifTrue: [ self recursiveCollapse: each on: aScript ] ]! !

!SUTreeReport methodsFor: 'rendering' stamp: 'lr 11/29/2007 17:03'!
renderBodyOn: html
	"Render the body of the tree report."
	
	self renderRows: roots level: 0 on: html! !

!SUTreeReport methodsFor: 'rendering' stamp: 'lr 11/11/2008 23:11'!
renderContentOn: html
	uids := IdentityDictionary new.
	html table 
		cellspacing: 0;
		class: self cssClass;
		with: [ self renderTableOn: html ]! !

!SUTreeReport methodsFor: 'rendering' stamp: 'lr 1/14/2008 21:02'!
renderHeadOn: html
	"Display the column titles of the tree report."
	
	html tableRow: [
		columns do: [ :each | 
			html tableHeading: each label ] ]! !

!SUTreeReport methodsFor: 'rendering' stamp: 'lr 3/25/2008 22:18'!
renderRow: anObject level: anInteger on: html
	"Render a specific row anObject at level anInteger."
	
	html tableRow id: (self uid: anObject on: html); with: [
		columns keysAndValuesDo: [ :index :each |
			html tableData: [
				index = 1 
					ifFalse: [ each render: anObject on: html ]
					ifTrue: [ each render: anObject indent: anInteger on: html ] ] ] ]! !

!SUTreeReport methodsFor: 'rendering' stamp: 'lr 7/25/2011 18:41'!
renderRowIndent: anObject level: anInteger on: html
	anInteger timesRepeat: [ html div class: 'space' ].
	html div
		class: 'space';
		with: [ 
			(expandableBlock value: anObject) ifTrue: [ 
				html anchor
					class: 'expanded' if: (expanded includes: anObject);
					onClick: ((html prototype evaluator)
						callback: [ :script | self toggle: anObject level: anInteger on: script ];
						return: false) ] ]! !

!SUTreeReport methodsFor: 'rendering' stamp: 'lr 1/13/2008 11:18'!
renderRows: aCollection level: anInteger on: html
	aCollection do: [ :each |
		self renderRow: each level: anInteger on: html.
		(expanded includes: each) ifTrue: [
			self 
				renderRows: (childrenBlock value: each)
				level: anInteger + 1 on: html ] ]! !

!SUTreeReport methodsFor: 'rendering' stamp: 'lr 2/1/2008 12:01'!
renderTableOn: html
	html tableHead: [ self renderHeadOn: html ].
	html tableBody: [ self renderBodyOn: html ]! !

!SUTreeReport methodsFor: 'accessing' stamp: 'lr 11/29/2007 17:00'!
roots: aCollection
	roots := aCollection! !

!SUTreeReport methodsFor: 'scripts' stamp: 'lr 11/29/2007 08:52'!
toggle: anObject level: anInteger on: aScript
	(expanded includes: anObject)
		ifTrue: [ self collapse: anObject level: anInteger on: aScript ]
		ifFalse: [ self expand: anObject level: anInteger on: aScript ]! !

!SUTreeReport methodsFor: 'accessing' stamp: 'lr 1/14/2008 20:31'!
treeReportColumnClass
	^ SUTreeReportColumn! !

!SUTreeReport methodsFor: 'private' stamp: 'lr 11/22/2007 22:45'!
uid: anObject on: html
	^ uids at: anObject ifAbsentPut: [ html nextId ]! !

WAComponent subclass: #SUWindow
	instanceVariableNames: 'title component id updateBlock componentBlock extent origin properties collapsed visible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUWindow class methodsFor: 'instance creation' stamp: 'lr 7/25/2011 19:47'!
on: aBlock
	^ self new
		componentBlock: aBlock;
		yourself! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
children
	^ Array with: component! !

!SUWindow methodsFor: 'actions' stamp: 'obi 1/26/2010 13:07'!
close
	visible := false! !

!SUWindow methodsFor: 'accessing-properties' stamp: 'lr 7/25/2011 18:41'!
closeButtonEnabled
	^ self propertiesAt: #closeButton ifAbsent: [ true ]! !

!SUWindow methodsFor: 'accessing-properties' stamp: 'obi 7/22/2008 20:33'!
closeButtonEnabled: aBoolean
	self propertiesAt: #closeButton put: aBoolean! !

!SUWindow methodsFor: 'scripting' stamp: 'obi 5/21/2010 20:16'!
closeOn: script
	self close.
	script prototype element
		id: self componentId;
		remove.
	script scriptaculous effect
		id: self windowId;
		duration: 0.5; fade! !

!SUWindow methodsFor: 'scripting' stamp: 'pmm 6/26/2011 13:35'!
collapseOn: script
	collapsed 
		ifFalse: [
			script prototype element
				id: self windowId;
				styleAt: 'height' put: self titleHeight greaseString , 'px'.
			script prototype element
				id: self containerId; hide ]
		ifTrue: [
			script prototype element
				id: self windowId;
				styleAt: 'height' put: extent y greaseString, 'px'.
			script prototype element
				id: self containerId;
				show ].
	collapsed := collapsed not
! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
collapsed
	^ collapsed! !

!SUWindow methodsFor: 'accessing' stamp: 'obi 6/26/2008 20:34'!
collapsed: aBoolean
	collapsed := aBoolean! !

!SUWindow methodsFor: 'accessing' stamp: 'obi 6/24/2008 21:31'!
component: aComponent
	component := aComponent! !

!SUWindow methodsFor: 'accessing' stamp: 'obi 1/26/2010 13:00'!
componentBlock: aBlock
	componentBlock := aBlock fixCallbackTemps! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
componentId
	^ 'comp_' , self windowId! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
containerId
	^ 'container_' , self windowId! !

!SUWindow methodsFor: 'accessing' stamp: 'obi 6/24/2008 19:44'!
cssClass
	^ 'suWindow'! !

!SUWindow methodsFor: 'private' stamp: 'jf 9/30/2009 01:10'!
cssContainerExtent
	^ 'width:' , extent x greaseString , 'px;height:' , (extent y - 16) greaseString , 'px;'! !

!SUWindow methodsFor: 'private' stamp: 'lr 7/25/2011 19:57'!
cssExtent
	^ 'width:' , extent x greaseString , 'px;height:' , extent y greaseString , 'px;'! !

!SUWindow methodsFor: 'private' stamp: 'jf 9/30/2009 01:10'!
cssOrigin
	^ 'left:' , origin x greaseString , 'px;top:' , origin y greaseString , 'px;'! !

!SUWindow methodsFor: 'accessing' stamp: 'obi 6/29/2008 19:25'!
extent: aPoint
	extent := aPoint! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
id
	^ id! !

!SUWindow methodsFor: 'accessing' stamp: 'obi 6/26/2008 19:42'!
id: aId
	id := aId! !

!SUWindow methodsFor: 'initialization' stamp: 'obi 6/28/2008 19:45'!
initialize
	super initialize.
	extent := 300 @ 200.
	origin := 100 @ 100.
	title := 'SU_Window'.
	componentBlock := [  ].
	collapsed := false.
	visible := false! !

!SUWindow methodsFor: 'testing' stamp: 'obi 6/28/2008 19:45'!
isVisible
	^ visible! !

!SUWindow methodsFor: 'accessing-properties' stamp: 'lr 7/25/2011 18:41'!
minimizeButtonEnabled
	^ self propertiesAt: #minimizeButton ifAbsent: [ true ]! !

!SUWindow methodsFor: 'accessing-properties' stamp: 'obi 7/22/2008 20:34'!
minimizeButtonEnabled: aBoolean
	self propertiesAt: #minimizeButton put: aBoolean! !

!SUWindow methodsFor: 'scripting' stamp: 'obi 7/23/2008 20:37'!
openOn: aScript 
	self 
		openOn: aScript
		hidden: false! !

!SUWindow methodsFor: 'scripting' stamp: 'pmm 6/26/2011 13:36'!
openOn: aScript hidden: aBoolean
	self isVisible
		ifFalse: [
			visible := true.
			aBoolean ifFalse: [ self showOn: aScript ].
			aScript prototype element
				id: self windowId;
				styleAt: 'left' put: origin x greaseString, 'px';
				styleAt: 'top' put: origin y greaseString, 'px'.
			aScript prototype element
				id: self containerId;
				insert: [ :html |
					self setComponent.
					self renderComponentOn: html ] ].! !

!SUWindow methodsFor: 'accessing' stamp: 'obi 6/28/2008 19:31'!
origin: aPoint
	origin := aPoint! !

!SUWindow methodsFor: 'public' stamp: 'obi 1/26/2010 12:59'!
originX: x y: y
	self origin: (Point x: x asNumber y: y asNumber + 16)
! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 18:41'!
properties
	^ properties ifNil: [ properties := Dictionary new ]! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 18:41'!
propertiesAt: aKey
	^ self properties at: aKey ifAbsent: [  ]! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
propertiesAt: aKey ifAbsent: aBlock
	^ self properties at: aKey ifAbsent: aBlock! !

!SUWindow methodsFor: 'accessing' stamp: 'obi 6/28/2008 20:03'!
propertiesAt: aKey put: aValue
	self properties at: aKey put: aValue! !

!SUWindow methodsFor: 'rendering' stamp: 'lr 7/25/2011 18:41'!
renderBodyOn: html
	html div
		class: 'title';
		id: self titleId;
		with: [ self renderTitleOn: html ].
	html div
		class: 'container';
		style: self cssContainerExtent;
		id: self containerId
! !

!SUWindow methodsFor: 'rendering' stamp: 'lr 7/25/2011 18:41'!
renderCloseOn: html
	self closeButtonEnabled
		ifTrue: [ html anchor
					title: 'Close';
					onClick: (html prototype evaluator
								callback: [ :script |
									self closeOn: script];
									return: false);
					with: 'X' ]! !

!SUWindow methodsFor: 'rendering' stamp: 'obi 9/8/2008 20:48'!
renderComponentOn: html
	html div
		id: self componentId;
		with: component! !

!SUWindow methodsFor: 'rendering' stamp: 'jf 9/30/2009 01:10'!
renderContentOn: html 
	self close.
	collapsed := false.
	html div
		id: self windowId;
		script: (html scriptaculous draggable
				handle: self titleId;
				revert: false);
		class: self cssClass;
		style: 'display: none';
		style: 'z-index:' , self zIndex greaseString , ';' , self cssOrigin , self cssExtent;
		with: [ self renderBodyOn: html ]! !

!SUWindow methodsFor: 'rendering' stamp: 'lr 7/25/2011 18:41'!
renderMinimizeOn: html
	self minimizeButtonEnabled
		ifTrue: [
			html anchor
					title: 'Minimize';
					onClick: (html prototype evaluator
									callback: [:script | 
												self collapseOn: script];
												return: false);
					with: '-' ]! !

!SUWindow methodsFor: 'rendering' stamp: 'obi 9/8/2008 20:48'!
renderTitleOn: html
	html table
		class: 'title';
		style: 'width:100%';
		cellspacing: 0;
		cellpadding:0;
		with: [
			html tableRow: [
				html tableData
					style: 'width:100%';
					class: 'label';
					with: title.
				html tableData: [self renderMinimizeOn: html].
				html tableData: [self renderCloseOn: html] ] ] 
! !

!SUWindow methodsFor: 'private' stamp: 'lr 2/28/2009 22:36'!
setComponent
	component isNil
		ifTrue: [ component := componentBlock value: self ].
	updateBlock notNil
		ifTrue: [ updateBlock value: self value: component ]! !

!SUWindow methodsFor: 'scripting' stamp: 'obi 2/11/2009 20:58'!
showOn: aScript
	aScript scriptaculous effect id: self windowId; duration: 0.3; appear! !

!SUWindow methodsFor: 'accessing' stamp: 'obi 6/28/2008 20:08'!
title: aString
	title := aString! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
titleHeight
	^ 20! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
titleId
	^ 'title_' , self windowId! !

!SUWindow methodsFor: 'accessing-properties' stamp: 'lr 7/25/2011 18:41'!
tooltipKey
	^ self propertiesAt: #tooltipKey ifAbsent: [ #unknown ]! !

!SUWindow methodsFor: 'accessing-properties' stamp: 'obi 8/30/2008 14:29'!
tooltipKey: aKey
	self propertiesAt: #tooltipKey put: aKey! !

!SUWindow methodsFor: 'accessing' stamp: 'obi 8/30/2008 14:35'!
updateBlock: aBlock
	updateBlock := aBlock! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 18:41'!
windowId
	^ id ifNil: [ id := 'suwindow' ]! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 18:41'!
zIndex
	^ self propertiesAt: #zIndex ifAbsent: [ 999 ]! !

!SUWindow methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
zIndex: anInteger
	^ self propertiesAt: #zIndex put: anInteger! !

!WAComponent methodsFor: '*scriptaculous-components-call/answer' stamp: 'jf 12/19/2009 01:52'!
lightbox: aComponent
	"Display aComponent within a lightbox of the receiver. Note, that this does a full refresh displaying the lightbox. Also note, that this only works well, if you sent to the root component of your application."
	
	^ self wait: [ :cc | 
		self 
			show: aComponent
			onAnswer: cc
			delegation: (SULightbox new
				delegate: aComponent;
				yourself).
		WARenderNotification signal ]! !

!GRPackage class methodsFor: '*scriptaculous-components' stamp: 'lr 2/17/2010 15:11'!
scriptaculousComponents
	^ self new
		name: 'Scriptaculous-Components';
		description: 'A collection of AJAX based widgets written on top of script.aculo.us and Prototype.';
		addDependency: 'Scriptaculous-Core';
		addDependency: 'Seaside-Flow'; "Flow is used to implement #lightbox:"
		addDependency: 'Seaside-Widgets';  "SUDatePicker subclasses WAMiniCalendar"
		addDependency: 'Seaside-Component'; "WAComponent is extended"
		url: #seasideUrl;
		yourself! !

WADecoration subclass: #SULightbox
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SULightbox methodsFor: 'accessing' stamp: 'lr 11/4/2008 10:58'!
children
	^ super children copyWith: self delegate! !

!SULightbox methodsFor: 'accessing' stamp: 'lr 11/4/2008 10:55'!
delegate
	^ delegate! !

!SULightbox methodsFor: 'accessing' stamp: 'lr 11/4/2008 10:55'!
delegate: aComponent
	delegate := aComponent! !

!SULightbox methodsFor: 'testing' stamp: 'lr 11/4/2008 10:54'!
isDelegation
	^ true! !

!SULightbox methodsFor: 'accessing-scripts' stamp: 'lr 5/29/2007 20:15'!
lighter
	^ 'updateLightbox();Event.observe(window,"resize",function(){updateLightbox();});'! !

!SULightbox methodsFor: 'rendering' stamp: 'jf 1/23/2009 00:53'!
renderContentOn: html
	super renderContentOn: html.
	html div id: 'overlay'.
	html div
		id: 'lightbox';
		style: 'display: none';
		with: self delegate.
	html document addLoadScriptFirst: self lighter! !

!SULightbox methodsFor: 'accessing-scripts' stamp: 'obi 3/19/2008 20:09'!
script
	^ 'Object.extend(Position, {
	windowBounds: function() {
		var x = window.innerWidth
			|| document.documentElement.clientWidth
			|| document.body.clientWidth
			|| 0;
		var y = window.innerHeight
			|| document.documentElement.clientHeight
			|| document.body.clientHeight
			|| 0;
		return [x, y];
	}
});
Object.extend(Element, {
	fullscreen: function(element) {
		element = $(element);
		var bounds = Position.windowBounds();
		element.style.position = "absolute";
		element.style.left = element.style.top = 0;
		element.style.width = bounds[0] + "px";
		element.style.height = bounds[1] + "px";
	},
	center: function(element) {
		element = $(element);
		var extent = Element.getDimensions(element);
		var bounds = Position.windowBounds();
		var x = (bounds[0] - extent.width) / 2;
		var y = (bounds[1] - extent.height) / 2;
		x = x < 0 ? 0 : x; y = y < 0 ? 0 : y;
		element.style.position = "absolute";
		element.style.left = x + "px";
		element.style.top = y + "px";
	}
});
function updateLightbox() {//ie6 fix hide all select elements not inside the lightbox
	if (Prototype.Browser.IE) {if (navigator.userAgent.indexOf("MSIE 6") !!= -1) 
								{$$("select").invoke("setStyle", {visibility: "hidden"})
								$("lightbox").descendants().each(function(item) {item.setStyle({visibility: "visible"})})}};
	Element.fullscreen("overlay");
	Element.center("lightbox");
	Element.show("lightbox");
};'! !

!SULightbox methodsFor: 'accessing-scripts' stamp: 'lr 10/12/2006 16:05'!
style
	^ 'html { overflow: hidden; }
body { overflow: hidden; }
div#overlay {
	z-index: 9998;
	background-color: black;
	filter: alpha(opacity=40);
	-moz-opacity: 0.4;
	opacity: 0.4;
}
div#overlay[id] { position: fixed; }
div#lightbox { z-index: 9999; }'! !

WAObject subclass: #SURenderableItem
	instanceVariableNames: 'owner body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

SURenderableItem subclass: #SUNavigationItem
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUNavigationItem methodsFor: 'accessing' stamp: 'lr 1/10/2008 01:41'!
label
	^ label! !

!SUNavigationItem methodsFor: 'accessing' stamp: 'lr 1/10/2008 01:41'!
label: aString
	label := aString! !

!SURenderableItem class methodsFor: 'instance creation' stamp: 'lr 2/1/2008 16:44'!
on: aComponent body: anObject
	^ self basicNew initializeOn: aComponent body: anObject! !

!SURenderableItem methodsFor: 'accessing' stamp: 'lr 2/1/2008 16:43'!
body
	^ body! !

!SURenderableItem methodsFor: 'initialization' stamp: 'jf 3/13/2009 18:01'!
initializeOn: aComponent body: anObject
	self initialize.
	owner := aComponent.
	body := anObject! !

!SURenderableItem methodsFor: 'testing' stamp: 'lr 2/1/2008 16:44'!
isComponent
	"Answer true if the body of the receiver is a component, and therefor needs to be registered as a child."

	^ self body isKindOf: WAComponent! !

!SURenderableItem methodsFor: 'accessing' stamp: 'lr 2/1/2008 16:43'!
owner
	^ owner! !

!SURenderableItem methodsFor: 'rendering' stamp: 'lr 2/1/2008 16:43'!
renderOn: html 
	html render: self body! !

SURenderableItem subclass: #SUSplitterItem
	instanceVariableNames: 'min size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUSplitterItem methodsFor: 'initialization' stamp: 'obi 5/5/2008 20:27'!
initializeOn: aComponent body: anObject
	super initializeOn: aComponent body: anObject.
	size := '200px'.
	min := 50! !

!SUSplitterItem methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
min
	^ min! !

!SUSplitterItem methodsFor: 'accessing' stamp: 'lr 2/1/2008 16:39'!
min: aNumber
	min := aNumber! !

!SUSplitterItem methodsFor: 'accessing' stamp: 'lr 2/1/2008 16:38'!
size
	^ size! !

!SUSplitterItem methodsFor: 'accessing' stamp: 'lr 2/1/2008 16:39'!
size: aNumber
	size := aNumber! !

WAObject subclass: #SUTreeReportColumn
	instanceVariableNames: 'owner renderer label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUTreeReportColumn class methodsFor: 'instance creation' stamp: 'lr 1/14/2008 20:35'!
on: aComponent
	^ self basicNew initializeOn: aComponent! !

!SUTreeReportColumn methodsFor: 'initialization' stamp: 'jf 3/13/2009 18:02'!
initializeOn: aComponent
	self initialize.
	owner := aComponent! !

!SUTreeReportColumn methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
label
	^ label! !

!SUTreeReportColumn methodsFor: 'accessing' stamp: 'lr 1/14/2008 20:32'!
label: aString
	label := aString! !

!SUTreeReportColumn methodsFor: 'rendering' stamp: 'obi 5/21/2010 20:13'!
render: anObject indent: anInteger on: html
	html div class: 'indent'; with: [
		anInteger timesRepeat: [ html div class: 'block' ].
		html div class: 'block'; with: [
			(owner isExpandable: anObject) ifTrue: [
				html anchor
					class: 'expanded' if: (owner isExpanded: anObject);
					onClick: (html prototype evaluator 
						callback: [ :script | owner toggle: anObject level: anInteger on: script ];
						return: false) ] ].
		html div class: 'text'; with: [ self render: anObject on: html ] ]! !

!SUTreeReportColumn methodsFor: 'rendering' stamp: 'lr 1/14/2008 21:03'!
render: anObject on: html
	html render: (renderer value: anObject)! !

!SUTreeReportColumn methodsFor: 'accessing' stamp: 'lr 7/25/2011 19:57'!
renderer
	^ renderer! !

!SUTreeReportColumn methodsFor: 'accessing' stamp: 'lr 1/14/2008 20:32'!
renderer: aBlock
	renderer := aBlock! !

WAMiniCalendar subclass: #SUDatePicker
	instanceVariableNames: 'widgetId uid format origin containerId open'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUDatePicker class methodsFor: 'instance creation' stamp: 'obi 10/23/2008 19:40'!
on: aId 
	^ self 
		on: aId
		container: nil! !

!SUDatePicker class methodsFor: 'instance creation' stamp: 'obi 10/23/2008 19:40'!
on: aId container: buttonId 
	^ self new
		widgetId: aId;
		containerId: buttonId;
		yourself! !

!SUDatePicker methodsFor: 'scripting' stamp: 'lr 7/25/2011 18:47'!
ajaxCallbackFor: aDate on: html
	^ html prototype evaluator
		callback: [ :script | self scriptSelect: aDate on: script ];
		return: false! !

!SUDatePicker methodsFor: 'accessing' stamp: 'obi 10/23/2008 19:12'!
containerId
	"Answer the value of containerId"
	^ containerId! !

!SUDatePicker methodsFor: 'accessing' stamp: 'obi 10/23/2008 19:12'!
containerId: anObject 
	"Set the value of containerId"
	containerId := anObject! !

!SUDatePicker methodsFor: 'accessing' stamp: 'lr 7/25/2011 18:47'!
format
	"Answer the value of format"

	^ format ifNil: [ format := #(2 1 3 $/ 1 1) ]! !

!SUDatePicker methodsFor: 'accessing' stamp: 'obi 1/16/2008 21:34'!
format: anObject
	"Set the value of format"

	format := anObject! !

!SUDatePicker methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:07'!
formattedResult
	^ self date printFormat: self format! !

!SUDatePicker methodsFor: 'initialization' stamp: 'obi 10/23/2008 20:11'!
initialize
	super initialize.
	open := false.
	self date: Date today! !

!SUDatePicker methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:07'!
isOpen
	^ open! !

!SUDatePicker methodsFor: 'actions' stamp: 'obi 2/17/2008 20:04'!
nextMonthUpdateOn: aScript
	self nextMonth.
	self scriptUpdateOn: aScript! !

!SUDatePicker methodsFor: 'actions' stamp: 'obi 1/15/2008 21:34'!
nextYear
	self year: self year + 1! !

!SUDatePicker methodsFor: 'actions' stamp: 'obi 2/17/2008 20:05'!
nextYearUpdateOn: aScript
	self nextYear.
	self scriptUpdateOn: aScript
! !

!SUDatePicker methodsFor: 'scripting' stamp: 'lr 7/25/2011 18:46'!
openOn: aScript 
	| anElement |
	anElement := aScript prototype element id: containerId.
	anElement	
		absolutize;
		styleAt: 'left'
			put: origin x greaseString , 'px';
		styleAt: 'top'
			put: origin y greaseString , 'px'.
	self isOpen
		ifFalse: [
			anElement update: self.
			open := true ]! !

!SUDatePicker methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:07'!
origin
	^ origin! !

!SUDatePicker methodsFor: 'accessing' stamp: 'obi 10/23/2008 17:25'!
origin: aPoint
	origin := aPoint! !

!SUDatePicker methodsFor: 'actions' stamp: 'obi 2/17/2008 20:04'!
previousMonthUpdateOn: aScript
	self previousMonth.
	self scriptUpdateOn: aScript! !

!SUDatePicker methodsFor: 'actions' stamp: 'obi 1/15/2008 21:34'!
previousYear
	self year: self year - 1! !

!SUDatePicker methodsFor: 'actions' stamp: 'obi 2/17/2008 20:05'!
previousYearUpdateOn: aScript
	self previousYear.
	self scriptUpdateOn: aScript
! !

!SUDatePicker methodsFor: 'rendering' stamp: 'lr 7/25/2011 18:47'!
renderBodyOn: html
	html table
		cellspacing: 0;
		class: 'main';
		with: [ self renderCalendarOn: html ].

			! !

!SUDatePicker methodsFor: 'rendering' stamp: 'lr 7/25/2011 18:47'!
renderCalendarOn: html
	html tableRow: [
		html tableHeading
			colSpan: 9;
			with: [self renderMonthNavigationOn: html ] ].
	html tableRow
			class: 'calendarTitle';
			with: [
				self weekDays do: [:each |
					html tableData
						class: 'weekDay';
						with: each ] ].
	self weeksDo: [ :week | self renderRowForWeek: week on: html ].
	html tableRow: [
		html tableData
			colSpan: 9;
			with: [self renderYearNavigationOn: html] ]	

			! !

!SUDatePicker methodsFor: 'rendering' stamp: 'obi 10/23/2008 14:52'!
renderCellForDate: aDate on: html
	html tableData
		class: 'day';
		class: 'daySelected' if: self date = aDate;
		with: [
			aDate monthIndex = self monthIndex ifTrue: [
					(self canSelect: aDate)
						ifTrue: [
							html anchor
								class: 'today' if: aDate = Date today;
								onClick: (self ajaxCallbackFor: aDate on: html);
								with: aDate dayOfMonth ]
						ifFalse: [ html text: aDate dayOfMonth ] ] ]! !

!SUDatePicker methodsFor: 'rendering' stamp: 'lr 7/25/2011 18:47'!
renderContentOn: html
	uid ifNil: [ uid := html nextId ].
	html div
		id: uid;
		class: 'calendar';
		with: [ self renderBodyOn: html ]! !

!SUDatePicker methodsFor: 'rendering' stamp: 'obi 5/21/2010 20:11'!
renderMonthNavigationOn: html
html table class: 'monthTable';
	cellspacing:0;
	with: [	
		html tableRow
			class: 'monthRow';
			with: [
				html tableData
					class: 'calendarPrevious';
					with: [
						html anchor
							callback: [self previousMonth];
							onClick: (html prototype evaluator
										callback: [:script |
										self previousMonthUpdateOn: script];
										return: false);
							with: '<<' ].
				html tableData class: 'monthCurrent'; with: (Date nameOfMonth: self monthIndex).
				html tableData
					class: 'calendarNext';
					with: [html anchor
							callback: [self nextMonth];
							onClick: (html prototype evaluator
										callback: [:script | 
											self nextMonthUpdateOn: script];
											return: false);
							with: '>>'] ] ]! !

!SUDatePicker methodsFor: 'rendering' stamp: 'obi 5/21/2010 20:11'!
renderYearNavigationOn: html
	html table
		class: 'yearTable';
		cellspacing:0;
		with: [	
			html tableRow: [
				html tableData
					class: 'year';
					with: [
						html anchor
							callback: [self previousYear];
							onClick:	(html scriptaculous evaluator
										callback: [:script |
											self previousYearUpdateOn: script];
											return: false);
							with: (self year - 1) ].
				html tableData
					class: 'year';
					class: 'yearCurrent';
					with: (self year name).
				html tableData
					class: 'year';
					with: [
						html anchor
							callback: [self nextYear];
							onClick: ((html prototype evaluator)
										callback: [:script | self nextYearUpdateOn: script];
										return: false);
							with: (self year + 1) ] ] ]! !

!SUDatePicker methodsFor: 'scripting' stamp: 'obi 5/23/2010 09:53'!
scriptSelect: aDate on: script 
	"Ajax select"
	self select: aDate.
	widgetId isNil ifTrue: [ ^ self ].
	script prototype element
		id: widgetId;
		access: 'value';
		assign: self formattedResult.
	script prototype element
		id: uid;
		remove.
	open := false! !

!SUDatePicker methodsFor: 'scripting' stamp: 'lr 7/25/2011 18:47'!
scriptUpdateOn: script
	script prototype element
		id: uid;
		update: [ :r | self renderBodyOn: r ]! !

!SUDatePicker methodsFor: 'public' stamp: 'lr 7/25/2011 18:47'!
setOriginWith: aString
	| anArray |
	anArray := (aString subStrings: ',')
		collect: [ :each | each select: [ :char | char isDigit ] ].
	anArray size > 1
		ifTrue: [ self origin: (Point x: (anArray at: 1) asNumber y: (anArray at: 2) asNumber + 20) ].! !

!SUDatePicker methodsFor: 'accessing' stamp: 'obi 1/16/2008 20:58'!
states
	"Answer a collection of states that should be backtracked."

	^ #()! !

!SUDatePicker methodsFor: 'accessing' stamp: 'obi 1/15/2008 22:04'!
uid
	"Answer the value of uid"

	^ uid! !

!SUDatePicker methodsFor: 'accessing' stamp: 'obi 1/15/2008 22:04'!
uid: anObject
	"Set the value of uid"

	uid := anObject! !

!SUDatePicker methodsFor: 'updating' stamp: 'lr 9/8/2009 12:40'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot stylesheet url: SUComponentLibrary / #datePickerCss! !

!SUDatePicker methodsFor: 'accessing' stamp: 'obi 1/15/2008 22:04'!
widgetId
	"Answer the value of widgetId"

	^ widgetId! !

!SUDatePicker methodsFor: 'accessing' stamp: 'obi 1/15/2008 22:04'!
widgetId: anObject
	"Set the value of widgetId"

	widgetId := anObject! !

SUDatePicker subclass: #SUDateTimePicker
	instanceVariableNames: 'showSeconds hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Core'!

!SUDateTimePicker methodsFor: 'scripting' stamp: 'lr 7/25/2011 18:48'!
ajaxCallbackFor: aDate on: html
	^ html prototype evaluator
		callback: [ :script | 
			self select: aDate.
			self scriptUpdateOn: script ];
		return: false! !

!SUDateTimePicker methodsFor: 'private' stamp: 'jf 9/30/2009 01:04'!
convertToInteger: aString max: maxValue 
	| anInteger |
	anInteger := aString greaseInteger.
	anInteger isNil ifTrue: [ ^ 0 ].
	^ (anInteger max: 0) min: maxValue! !

!SUDateTimePicker methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:07'!
formattedResult
	^ super formattedResult , ' ' , (self withLeadingZero: hours) , ':' , (self withLeadingZero: minutes) , ':'
		, (self withLeadingZero: seconds)! !

!SUDateTimePicker methodsFor: 'accessing' stamp: 'obi 10/23/2008 13:26'!
hours
	^ hours! !

!SUDateTimePicker methodsFor: 'accessing' stamp: 'obi 10/23/2008 14:28'!
hours: anObject
	hours := self convertToInteger: anObject max: 23! !

!SUDateTimePicker methodsFor: 'initialization' stamp: 'obi 10/27/2008 14:27'!
initialize
	| now |
	super initialize.
	showSeconds := false.
	now := DateAndTime now.
	hours := now hour.
	minutes := now minute.
	seconds := 0! !

!SUDateTimePicker methodsFor: 'accessing' stamp: 'obi 10/23/2008 13:26'!
minutes
	^ minutes! !

!SUDateTimePicker methodsFor: 'accessing' stamp: 'obi 10/23/2008 14:14'!
minutes: anObject
	minutes := self convertToInteger: anObject max: 59! !

!SUDateTimePicker methodsFor: 'rendering' stamp: 'obi 10/23/2008 13:20'!
renderBodyOn: html
	html table
		cellspacing: 0;
		class: 'main';
		with: [
			self renderCalendarOn: html.
			self renderTimeOn: html	].

			! !

!SUDateTimePicker methodsFor: 'rendering' stamp: 'obi 9/6/2009 21:40'!
renderTimeOn: html
	html tableRow: [
		html tableData
			class: 'time';
			colSpan: 9;
			align: 'center';
			with: [
				html form 
					id: self timeId;
					with: [
						html textInput
							maxLength: 2;
							value: (self withLeadingZero: hours);
							callback: [:v | self hours: v].
						html text: ':'.
						html textInput
							maxLength: 2;
							value: (self withLeadingZero: minutes);
							callback: [:v | self minutes: v].
						showSeconds ifTrue: [
							html text: ':'.
							html textInput
								maxLength: 2;
								value: (self withLeadingZero: seconds);
								callback: [:v | self seconds: v] ].
						html space.
						html anchor
							class: 'button';
							onClick: (self triggerFormOn: html);
							with: 'Ok' ] ] ]! !

!SUDateTimePicker methodsFor: 'accessing' stamp: 'obi 10/23/2008 13:26'!
seconds
	^ seconds! !

!SUDateTimePicker methodsFor: 'accessing' stamp: 'obi 10/23/2008 14:14'!
seconds: anObject
	seconds := self convertToInteger: anObject max: 59! !

!SUDateTimePicker methodsFor: 'accessing' stamp: 'lr 7/25/2011 20:07'!
timeId
	^ 'time_' , uid! !

!SUDateTimePicker methodsFor: 'scripting' stamp: 'lr 7/25/2011 18:47'!
triggerFormOn: html
	^ html prototype evaluator
		triggerForm: self timeId;
		callback: [ :script | self scriptSelect: self date on: script ];
		return: false! !

!SUDateTimePicker methodsFor: 'private' stamp: 'jf 9/30/2009 01:10'!
withLeadingZero: anInteger 
	^ anInteger < 10 
		ifTrue: [ '0' , anInteger greaseString ]
		ifFalse: [ anInteger greaseString ]! !

WAFileLibrary subclass: #SUComponentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scriptaculous-Components-Libraries'!

!SUComponentLibrary methodsFor: 'styles' stamp: 'lr 1/10/2008 02:22'!
accordionCss
	^ '.accordion dt,
.accordion dd {
	margin: 0;
	padding: 0;
	overflow: auto;
}
.accordion dt {
	padding: 0.25em;
	background-color: #c5dea1;
}
.accordion dt.active {
	background-color: #e8a400;
}
.accordion dt a:link,
.accordion dt a:visited {
	color: #444;
	outline: none;
	display: block;
	padding: 0.25em;
	text-decoration: none;
}
.accordion dt.active a:link,
.accordion dt.active a:visited {
	color: #000;
}
.accordion dd {
	background-color: #fff;
}'! !

!SUComponentLibrary methodsFor: 'uploaded' stamp: 'pmm 2/17/2011 07:39'!
arrowdownGif
	^ #(71 73 70 56 57 97 16 0 16 0 196 17 0 129 129 129 176 176 176 212 212 212 234 234 234 251 251 251 157 157 157 193 193 193 229 229 229 133 133 133 142 142 142 243 243 243 232 232 232 233 233 233 149 149 149 147 147 147 203 203 203 128 128 128 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 249 4 1 0 0 17 0 44 0 0 0 0 16 0 16 0 0 5 58 96 36 142 100 105 158 104 106 50 79 235 182 139 233 64 116 77 55 166 97 219 134 73 36 59 72 130 112 18 4 5 169 130 173 160 58 0 158 128 131 42 18 160 5 166 17 5 2 161 192 70 6 3 175 120 236 13 1 0 59) asByteArray! !

!SUComponentLibrary methodsFor: 'uploaded' stamp: 'pmm 2/17/2011 07:39'!
arrowrightGif
	^ #(71 73 70 56 57 97 16 0 16 0 196 17 0 129 129 129 176 176 176 212 212 212 234 234 234 251 251 251 157 157 157 193 193 193 229 229 229 133 133 133 142 142 142 243 243 243 232 232 232 233 233 233 149 149 149 147 147 147 203 203 203 128 128 128 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 249 4 1 0 0 17 0 44 0 0 0 0 16 0 16 0 0 5 54 96 36 142 100 105 158 104 106 46 141 65 168 226 3 65 137 0 203 51 84 28 41 158 3 1 197 201 55 3 64 16 3 19 17 98 68 42 115 197 224 16 186 235 205 106 48 134 195 5 235 122 191 167 16 0 59) asByteArray! !

!SUComponentLibrary methodsFor: 'styles' stamp: 'lr 7/25/2011 20:03'!
carouselComponentCss
	^ '.carouselComponent {position:relative;border:1px solid #ccc;overflow:hidden}
 .carouselComponent .carousel-list-h {width:10000px;
		position:relative;
		z-index:1}
 .carouselComponent .carousel-list-v {height:10000px;
		position:relative;
		z-index:1}
 .carouselComponent .carousel-element {
		list-style:none;
		overflow:hidden	}
.carousel-float-h {float:left}
.carousel-float-v {clear:left;float:left}
.carouselComponent .buttonh {position:relative;height:100%;float:left;background:#c5dea1;vertical-align:middle;cursor:pointer}
.carouselComponent .buttonv {clear:left;position:relative;text-align:center;background:#c5dea1;cursor:pointer}
  .carouselComponent .clip-region { border:1px dotted #ccc;
		overflow:hidden;
		margin:0px auto;
		position:relative; 
	}'! !

!SUComponentLibrary methodsFor: 'styles' stamp: 'obi 2/17/2008 19:54'!
carouselCss
	^ '.carousel .nav {position:relative;padding:5px;border:1px solid #ccc;width:140px;height:100%}
	.carousel .inner {position:relative;margin:2px;overflow:hidden}
	.carousel .move {background:white;position:relative;top:0;left:0}
	.carousel .body {border:1px solid #ccc}
	.carousel .action {border:1px solid #ccc;background:#ffffe0;padding:2px}
	.carousel .nav a {text-decoration:none;color:black}
	.carousel td.right {text-align:right}
	.carousel .nav .active {background:#99ccff;border:1px dotted #ccc}' ! !

!SUComponentLibrary methodsFor: 'styles' stamp: 'obi 10/24/2008 20:20'!
datePickerCss
	^ '.calendar {font-family:Arial;font-size:10px;width:150px;z-index:999}
	.calendar .day {text-align:center;border:1px solid #ccc}
	.calendar .main {border:1px solid black;background:#fff}
	.calendar .daySelected {background:#e0e0e0;font-weight:bold}
	.calendar a {text-decoration:none;color:black;}
	.calendar .day a {color:#336699;display:block;width:16px}
	.calendar .day a:hover {background:#aaa;color:white}
	.calendar .monthTable {width:100%}
	.calendar .monthRow {background:#e0e0e0}
	.calendar .calendarTitle {background-color:#f0f0f0}
	.calendar .monthCurrent {font-size:12px;font-family:verdana;width:100%}
	.calendar .yearTable {width:100%;border-top:1px solid #ccc}
	.calendar .year {font-size:10px;font-family:verdana;text-align:center}
	.calendar .year a:hover {background:#aaa;color:white}
	.calendar .yearCurrent {background:#e0e0e0;font-weight:bold}
	.calendar .day a.today {text-decoration:underline;font-weight:bold}
	.calendar .weekDay {text-align:center}
	.calendar .time {border:1px solid #ccc}
	.calendar .time input.text {width:18px}
	.calendar .time a.button {border:1px solid #aaa;background:#ccc;padding:2px;-moz-border-radius:5px;border-radius:5px}
	.calendar .time a.button:hover {background:#69c}' ! !

!SUComponentLibrary methodsFor: 'accessing' stamp: 'obi 6/26/2008 20:05'!
selectorsToInclude
	^ #( treeReportCss tabPanelCss accordionCss titlePaneCss carouselCss carouselComponentCss datePickerCss windowCss splitterCss)! !

!SUComponentLibrary methodsFor: 'styles' stamp: 'obi 5/5/2008 20:40'!
splitterCss
	^ '.splitter-horizontal .handle {
	height: 5px;
	position: relative;
	background-color: #c5dea1;
	cursor: row-resize;
}

.splitter-vertical div {
	float: left;
}
.splitter-vertical div.handle {
	float: left;
	width: 5px;
	height: 200px;
	position: relative;
	cursor: col-resize;
	background-color: #c5dea1;

}'! !

!SUComponentLibrary methodsFor: 'styles' stamp: 'lr 1/5/2008 20:01'!
tabPanelCss
	"Based on: http://www.kalsey.com/tools/csstabs/"

	^ '.tabPanel ul.head {
	margin: 0;
	padding-left: 1em;
	padding-bottom: 19px;
	border-bottom: 1px solid #ccc;
}
.tabPanel ul.head li	{
	margin: 0;
	padding: 0;
	display: inline;
	list-style-type: none;
}
.tabPanel ul.head a:link, 
.tabPanel ul.head a:visited {
	float: left;
	color: #444;
	outline: none;
	line-height: 14px;
	margin-right: 1em;
	background: #eee;
	text-decoration: none;
	border: 1px solid #ccc;
	padding: 2px 1em 2px 1em;
}
.tabPanel ul.head a:link.active, 
.tabPanel ul.head a:visited.active {
	color: #000;
	background: #fff;
	border-bottom: 1px solid #fff;
}
.tabPanel ul.head a:hover {
	background-color: #fff;
}'! !

!SUComponentLibrary methodsFor: 'styles' stamp: 'obi 2/17/2008 20:23'!
titlePaneCss
	^ '.titlePane .title {background:#e0e0e0;border-bottom-color:black;border-bottom-style:dotted;border-bottom-width:1px}
	.titlePane {border:4px solid #ccc;width:450px;overflow:hidden}
	.titlePane .body {background:white;height:100%;width:100%;overflow:hidden}
	.titlePane .closed {height:0px;display:none}
	.titlePane a.title {cursor:pointer;
					outline: none;
					padding: 0.25em;
					display: block;
					text-decoration:none;
					color:black}
	.titlePane td.label {width:100%;white-space:nowrap}
	.titlePane .gfx {background-position: center center;
					width:16px;height:10px;
					background-image: url(arrowright.gif)}
	.titlePane .gfxopen {background-position: center center;
					width:16px;height:10px;
					background-image: url(arrowdown.gif)}
	'! !

!SUComponentLibrary methodsFor: 'styles' stamp: 'lr 2/1/2008 11:40'!
treeReportCss
	^ '.treeReport {
	border: solid 1px #ccc;
	border-collapse: collapse;
	background-color: white;
}
.treeReport th {
	padding: 4px;
	text-align: left;
	background-color: #ccc;
}
.treeReport td {
	text-align: left;
	vertical-align: top;
	padding-right: 5px;
}
.treeReport td .indent {
	height: 16px;
	overflow: hidden;
	white-space: nowrap;
}
.treeReport td .indent .block,
.treeReport td .indent .text {
	float: left;
	height: 16px;
}
.treeReport td .indent .block {
	width: 16px;
}
.treeReport td .indent .block a {
	width: 16px;
	height: 16px;
	outline: none;
	display: block;
	background-position: center center;
	background-image: url(arrowright.gif);
}
.treeReport td .indent .block a.expanded {
	background-image: url(arrowdown.gif);
}'! !

!SUComponentLibrary methodsFor: 'styles' stamp: 'obi 11/30/2008 10:25'!
windowCss
	^ 'div.suWindow {background:#e0e0e0;border:1px solid #888;overflow:hidden;position:fixed;-moz-border-radius:5px;border-radius:5px}
	.suWindow .container {overflow:auto;padding:2px}
	.suWindow .title {cursor:move;background:#888;color:white;height:16px; padding:2px 2px 3px 3px}
	.suWindow .title a {text-decoration:none;padding:2px;}' ! !
